#include <stdio.h>
#ifdef  UNIX
#include <signal.h>
#endif

#include "z80-cpu.h"
#include "decode.h"
#include "z80-mon.h"

static unsigned long inter_mask;


static void
dump_cpu(void)
{
  _uchar  a, buffer[8];
  int  i;
  static FILE *fp;
  if (!fp)
     if (!(fp=fopen(".CPU","w")))
        return;
  rewind(fp);
  i=0;
  buffer[i++]=F;
  buffer[i++]=A;
  buffer[i++]=B;
  buffer[i++]=C;
  buffer[i++]=D;
  buffer[i++]=E;
  buffer[i++]=H;
  buffer[i++]=L;
  fwrite(buffer,1,8,fp);
  i=0;
  buffer[i++]=F_;
  buffer[i++]=A_;
  buffer[i++]=B_;
  buffer[i++]=C_;
  buffer[i++]=D_;
  buffer[i++]=E_;
  buffer[i++]=H_;
  buffer[i++]=L_;
  fwrite(buffer,1,8,fp);
  i=0;
  buffer[i++]= IX&255;
  buffer[i++]= IX>>8;
  buffer[i++]= IY&255;
  buffer[i++]= IY>>8;
  buffer[i++]= SP&255;
  buffer[i++]= SP>>8;
  buffer[i++]= PC&255;
  buffer[i++]= PC>>8;
  fwrite(buffer,1,8,fp);
  a= (IFF0&1) | (IFF1&1)<<1 | (IFF2&1)<<2;
  a|= (cpu_halts&1) << 3;
  a|= (IM&3) << 4;
  a|= (cpu_iorq&1) << 6;
  a|= (cpu_int&1) << 7;
  i=0;
  buffer[i++]= I;
  buffer[i++]= R;
  buffer[i++]= DATA;
  buffer[i++]= a;
  buffer[i++]= ticks&255;
  buffer[i++]= ticks>>8&255;
  buffer[i++]= ticks>>16&255;
  buffer[i++]= ticks>>24;
  fwrite(buffer,1,8,fp);
  fflush(fp);
}


#ifdef  UNIX

void interrupt_catcher(int signo)
{
   if (signo == SIGTRAP)
      dump_cpu();
   else if (signo == SIGUSR1)
      cpu_reset=1;
   else if (signo == SIGUSR2)
      IFF3=1;
   else
   {  inter_mask |= (unsigned long)1<<signo;
      if (signo != SIGABRT)
         cpu_int=1;
   }
   signal(signo,interrupt_catcher);
}

void init_interrupt_handling(void)
{
int i;
for (i=0;i<32;i++)
    signal(i, interrupt_catcher);
signal(SIGHUP, finish);
signal(SIGTERM,finish);
inter_mask=0;
/* still free no: SIG_KILL(9) , SIGSTOP(17-19), SIGCONT(17-19)
                  SIGCHLD(17-20), SIGTSTP(18-20),  0
   maybe useful simulating key board interrupts ? */
}

#else

void interrupt_catcher(int signo)
{
}

void init_interrupt_handling(void)
{
inter_mask=0;
}

#endif


/* during this routine an interrupt may occur but get not lost */
void check_pending_interrupts(void)
{
  if (inter_mask)
  { unsigned long mask;
    unsigned char c;
    if (inter_mask & 1<<SIGABRT)
       inter_mask=0, cpu_wait=1;
    else
       for (mask=1,c=0;c<32;c++,mask<<=1)
          if (inter_mask&mask)
          {  inter_mask ^= mask;
             inter_mask = 0;   /* level triggering */
			 DATA=0xff;
             if (IFF1)
                inter_handler();   /* address on data bus */
			 break;
          }
  }
}
